#===============================================================================
# Copyright 2014-2017 Intel Corporation All Rights Reserved.
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#===============================================================================

## <a name="DAAL-EXAMPLE-PY-EM_GMM_BATCH"></a>
## \example em_gmm_dense_batch.py

from daal.data_management import FileDataSource, DataSourceIface
from daal.algorithms.em_gmm import init, Batch, data, inputValues, weights, means, covariances
import os, inspect, sys
from os.path import join as jp
utils_folder = os.path.realpath(os.path.abspath(jp(os.path.split(inspect.getfile(inspect.currentframe()))[0], "..")))
if utils_folder not in sys.path:
    sys.path.insert(0, utils_folder)
from utils import printNumericTable

DAAL_PREFIX = jp('..', 'data')

# Input data set parameters
datasetFileName = jp(DAAL_PREFIX, 'batch', 'em_gmm.csv')
nComponents = 2

if __name__ == "__main__":

    # Initialize FileDataSource<CSVFeatureManager> to retrieve the input data from a .csv file
    dataSource = FileDataSource(
        datasetFileName,
        DataSourceIface.doAllocateNumericTable,
        DataSourceIface.doDictionaryFromContext
    )
    nFeatures = dataSource.getNumberOfColumns()

    # Retrieve the data from the input file
    dataSource.loadDataBlock()

    # Create algorithm objects to initialize the EM algorithm for the GMM
    # computing the number of components using the default method
    initAlgorithm = init.Batch(nComponents)

    # Set an input data table for the initialization algorithm
    initAlgorithm.input.set(init.data, dataSource.getNumericTable())

    # Compute initial values for the EM algorithm for the GMM with the default parameters
    resultInit = initAlgorithm.compute()

    # Create algorithm objects for the EM algorithm for the GMM computing the number of components using the default method
    algorithm = Batch(nComponents)

    # Set an input data table for the algorithm
    algorithm.input.setTable(data, dataSource.getNumericTable())
    algorithm.input.setValues(inputValues, resultInit)

    # Compute the results of the EM algorithm for the GMM with the default parameters
    result = algorithm.compute()

    # Print the results
    printNumericTable(result.getResult(weights), "Weights")
    printNumericTable(result.getResult(means), "Means")
    for i in range(nComponents):
        printNumericTable(result.getCovariances(covariances, i), "Covariance")
